﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;

namespace _1157068
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();
            radGridView1.AutoSizeColumnsMode = Telerik.WinControls.UI.GridViewAutoSizeColumnsMode.Fill;

            BindingList<DataClass> data = new BindingList<DataClass>();
            for (int i = 0; i < 10; i++)
            {
                if (i % 2 == 0)
                {
                    data.Add(new DataClass(new Analog()));
                }
                else
                {
                    data.Add(new DataClass(new Serial()));
                }
            }
            radGridView1.DataSource = data;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            FormatCells();
        }
        public void FormatCells()
        {
            foreach (var item in radGridView1.Rows)
            {
                //reset
                item.Cells["DataItem"].Style.CustomizeFill = false;

                //set style for Analog only
                var dataObj = item.DataBoundItem as DataClass;

                if (dataObj.DataItem is Analog)
                {
                    int value = int.Parse(((Analog)dataObj.DataItem).ToString());
                    if (value < 81)
                    {
                        var style = item.Cells["DataItem"].Style;
                        style.CustomizeFill = true;
                        style.BackColor = Color.Red;
                        style.GradientStyle = GradientStyles.Solid;
                    }
                }
            }
        }
    }
    class DataClass
    {
        public BaseClass DataItem { get; set; }
        public DataClass(BaseClass dataItem)
        {
            this.DataItem = dataItem;
        }

    }
    class BaseClass
    {
        public string Type { get; private set; }
        public BaseClass(string type)
        {
            this.Type = type;
        }
    }
    class Analog : BaseClass
    {
        static Random rnd = new Random();
        int value = 0;
        public Analog() : base("Analog")
        {
            value = rnd.Next(100);
        }
        public override string ToString()
        {
            return value.ToString();
        }
    }
    class Serial : BaseClass
    {
        public Serial() : base("Serial")
        { }
        public override string ToString()
        {
            return "Test";
        }
    }
}
